#include <stdlib.h>
#include <stdio.h>
#include "screen.h"
#include "jpeglib.h"
#ifdef __ON_MEMORY__
//#include "n_jpg1.h"
#include "n_jpg2.h"
#endif

#ifdef __ON_MEMORY__
extern FILE file_buf[256] ; /** FILE\̂̎ 256Gg **/
extern int  file_cur      ; /** ̃Ggԍ           **/
extern int  heap_top      ; /** mallocׂ̈heap̐擪         **/
#endif

int main()
{
/** for decompress **/
struct	jpeg_decompress_struct cinfo_d ;
struct	jpeg_error_mgr jerr_d ;
FILE	*fp_d ;
/** for compress   **/
struct  jpeg_compress_struct cinfo_c ;
struct  jpeg_error_mgr jerr_c ;
FILE    *fp_c ;

FILE	*fp1, *fp2 ;
int     y,x,bl,width ;
char	*tmp_buff ;
char    *msgdsp ;
unsigned int *dspvar ;
int     loops,l ; 

#if defined __POWERXVM__
struct VRAM_PIX *vp ;
#endif 

#ifdef __ON_MEMORY__
 /** heap̐擪Zbg **/
 heap_top = 0x600000 ;
 msgdsp=malloc(16*4) ;
 dspvar=malloc(sizeof(unsigned int)) ;
 /** fp_dZbg **/
 file_buf[file_cur]._p      = malloc(80*1024) ;
 file_buf[file_cur]._blksize=80*1024  ;
 file_buf[file_cur]._offset =0        ;
 fp_d=&file_buf[file_cur] ;
 memcpy(file_buf[file_cur]._p,n_jpg,JPG_FILE_SIZE) ;
 /** fp2Zbg **/
 file_buf[file_cur+1]._p      = malloc(80*1024) ;
 file_buf[file_cur+1]._blksize=0      ;
 file_buf[file_cur+1]._offset =0      ;
 fp_c=&file_buf[file_cur+1] ;
#else
 fp_d=fopen("n.jpg","rb") ;
 fp_c=fopen("z.jpg","wb") ;
#endif

 if( fp_d==NULL || fp_c==NULL ) exit(-3) ;
 strcpy(msgdsp,"passd set fp_d,fp_c") ;
 *dspvar=file_buf[file_cur+1]._p ;

#if defined __POWERXVM__
 vp=VRAM_TOP ;
#endif 

 loops=8 ;
 for( l=0 ; l<loops ; l++ ){
   cinfo_d.err = jpeg_std_error(&jerr_d);
   jpeg_create_decompress(&cinfo_d);
   jpeg_stdio_src(&cinfo_d, fp_d);
   jpeg_read_header(&cinfo_d, TRUE);
   strcpy(msgdsp,"passd set tmp_buff ") ;
   jpeg_start_decompress(&cinfo_d);
   
   bl=cinfo_d.output_width * cinfo_d.output_components ;
   tmp_buff = malloc( bl ) ;
   if( tmp_buff == NULL ) exit(-2) ;
   
   cinfo_c.err = jpeg_std_error(&jerr_c);
   jpeg_create_compress(&cinfo_c);
   jpeg_stdio_dest(&cinfo_c, fp_c);
   cinfo_c.image_width      = cinfo_d.output_width ;
   cinfo_c.image_height     = cinfo_d.output_height ;
   cinfo_c.input_components = 3 ;
   cinfo_c.in_color_space   = JCS_RGB ;
   jpeg_set_defaults(&cinfo_c);
   cinfo_c.comp_info[0].h_samp_factor=2 ;
   cinfo_c.comp_info[0].v_samp_factor=2 ;
   cinfo_c.err = jpeg_std_error(&jerr_c);
   jpeg_set_quality(&cinfo_c, 10, TRUE ) ;
   cinfo_c.smoothing_factor = 0 ;
   cinfo_c.optimize_coding  = FALSE ;
   jpeg_start_compress(&cinfo_c, TRUE); 
   
   y=0 ;
   strcpy(msgdsp,"passd set jpgvars ") ;
   while( cinfo_d.output_scanline < cinfo_d.output_height ){
     jpeg_read_scanlines(&cinfo_d, (JSAMPARRAY)&tmp_buff, 1 );
#if defined __POWERXVM__
     if( y<SCREEN_HEIGHT ){
       for( x=0 ; x<cinfo_d.output_width ; x++ ){
	 if( x >= SCREEN_WIDTH ) break ;
	 vp[y*VRAM_WIDTH+x].r=tmp_buff[x*3+0] ;
	 vp[y*VRAM_WIDTH+x].g=tmp_buff[x*3+1] ;
	 vp[y*VRAM_WIDTH+x].b=tmp_buff[x*3+2] ;
       }
     }
#endif
     jpeg_write_scanlines(&cinfo_c, (JSAMPARRAY)&tmp_buff, 1 );
     y++ ;
   }
   jpeg_finish_compress(&cinfo_c);
   jpeg_destroy_compress(&cinfo_c);   

   file_buf[file_cur+2] = file_buf[file_cur  ] ;
   file_buf[file_cur  ] = file_buf[file_cur+1] ;
   file_buf[file_cur+1] = file_buf[file_cur+2] ;
   file_buf[file_cur]._blksize  =file_buf[file_cur+1]._offset ;
   file_buf[file_cur]._offset   =0      ;
   file_buf[file_cur+1]._blksize=0      ;
   file_buf[file_cur+1]._offset =0      ;
 }
#if defined __POWERX__ || defined __POWERXVM__
 __end() ;
#else
 exit(0) ;
#endif
}
